#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"
#include "VVram.h"

static word PrintS(word vram, ptr<byte> p, bool right)
{
    byte c;
    while ((c = *p) != 0) {
        vram = PrintC(vram, c, right);
        right = !right;
        ++p;
    }
    return vram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 0 + 8, "SC", false); 
    PrintS(Vram + VramRowSize * 2 + 8, "ST", false);
    PrintByteNumber2(Vram + VramRowSize * 2 + 11, CurrentStage + 1, true);
    PrintS(Vram + VramRowSize * 4 + 8, "T", false);
    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 14 + 8;
        word vram;
        byte count;
        vram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            vram = Put2C(vram, Char_Man, true);
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    word vram;
    vram = PrintNumber5(Vram + VramRowSize * 0 + 9, Score, false);
    PrintC(vram, '0', true);
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 4 + 10, StageTime, true);
}

void PrintHeldKnives()
{
    word vram;
    byte count, i;
    bool right;

    vram = Vram + VramRowSize * 12 + 8;
    right = true;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        vram = Put(vram, Char_Kn_Left, right);
        right = !right;
        ++i;
        --count;
    }
    while (i != 4) {
        vram = Put(vram, Char_Space, right);
        right = !right;
        ++i;
    }
}

void PrintGameOver()
{
    constexpr byte Left = (VVramWidth - 9) / 4;
    PrintS(Vram + VramRowSize * 15 + Left, "GAME OVER", true);
    // PresendVram();
}

void PrintTimeUp() 
{
    constexpr byte Left = (VVramWidth - 6) / 4;
    PrintS(Vram + VramRowSize * 15 + Left, "TIME UP", true);
    // PresendVram();
}

void Title()
{
    ClearScreen(); 
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            //	M
            0x0c, 0x07, 0x07, 0x0b, 
            0x0c, 0x03, 0x03, 0x0f, 
            0x0c, 0x03, 0x03, 0x0f, 
            0x04, 0x01, 0x01, 0x05, 
            //	A
            0x00, 0x0e, 0x0d, 0x02, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x07, 0x05, 0x0f, 
            0x04, 0x01, 0x00, 0x05, 
            //	Z
            0x04, 0x05, 0x0d, 0x07, 
            0x00, 0x08, 0x07, 0x00, 
            0x08, 0x07, 0x00, 0x00, 
            0x04, 0x05, 0x05, 0x05, 
            //	Y
            0x0c, 0x03, 0x0c, 0x03, 
            0x04, 0x0b, 0x0e, 0x01, 
            0x00, 0x0c, 0x03, 0x00, 
            0x00, 0x04, 0x01, 0x00, 
        };
        constexpr byte LogoLength = 4;
        ptr<byte> p;
        word vram;
        vram = Vram + VramRowSize * 2;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (4) {
                bool right;
                right = false;
                repeat (4) {
                    vram = Put(vram, *p, right);
                    right = !right;
                    ++p;
                }
                vram += VramRowSize - 2;
            }
            vram += 2 - VramRowSize * 4;
        }
        // PrintS(Vram + VramRowSize * 6 + (VVramWidth - 6) / 2, "MINI", false);
    }
    PrintS(Vram + VramRowSize * 10 + (VVramWidth - 14) / 4, "PUSH SPACE KEY", false);
    PrintS(Vram + VramRowSize * 12 + (VVramWidth - 14) / 4, "OR RETURN KEY", false);
    PrintS(Vram + VramRowSize * 14 + (VVramWidth - 12) / 2, "INUFUTO 2023", false);
    // {
    //     byte c;
    //     word vram;
    //     vram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         vram = Put(vram, c);
    //         ++c;
    //         if ((c & 15) == 0) {
    //             vram += VramRowSize - 16;
    //         }
    //     }
    // //     // UpdateEnemyChars();
    // //     // SwitchChars();
    // //     // while (true) {
    // //     //     ++EnemyRowLeft;
    // //     //     UpdateEnemyChars();
    // //     //     SwitchChars();
    // //     //     WaitTimer(30);
    // //     // }
    // }
    // PresendVram();
}
